@echo off
: Rem - %1 is the file to scan %2 is the name of the result file %3
: Rem - is the sentinel file. The report from the scan is sent to the
: Rem - Result file. If No virus is found then the Result file is
: Rem - deleted prior to deleting the sentinel file. If a virus, or
: Rem - other error is found, then a message indicating the meaning
: Rem - of the return code is tacked on to the end of the result
: Rem - file. Deletion of the sentinel file is the last thing that
: Rem - takes place.
: Rem - Note 1: Some of the error codes should never occur, in this
: Rem - context, but I put them in anyway for documentation purposes,
: Rem - if nothing else.
: Rem - Note 2: There's colons in front of the Rem statements because
: Rem - blank labels process faster than Rem statements (the entire
: Rem - Rem statement is parsed even though it's a comment)
: Rem - No extended batch command features are used so this should
: Rem - work with*any* MS OS.
: Rem - Watch for wrapping of the batch file lines in this email
: Rem - message.  They are longer that the normal 70 CPL!.  The
: Rem - F-PROT commandline and echo line should NOT be wrapped.
: Rem -
: Rem - %4 is file name of attachment
: Rem - %5 is name of complete message

c:\programme\fprot\F-prot.exe %1 /ARCHIVE /DUMB /TYPE /NOMEM /noboot /PACKED /REPORT=%2 /WRAP

If Errorlevel 8 goto err8
If Errorlevel 7 goto err7
If Errorlevel 6 goto err6
If Errorlevel 5 goto err5
If Errorlevel 4 goto err4
If Errorlevel 3 goto err3
If Errorlevel 2 goto err2
If Errorlevel 1 goto err1
Del %2
goto Finished
:Err1
echo Abnormal termination - Unrecoverable Error >> %2
echo Internal error. English.tx0 or Sign.def or Macro.def missing/corrupted >> %2
goto Finished
:Err2
echo Selftest failed - program has been modified >> %2
goto Finished
:Err3
c:\programme\unixutils\grep Virus %2 > c:\scratch\result-filt.txt
c:\programme\unixutils\grep Infection %2 | c:\programme\unixutils\cut -d ">" -f 2 >> c:\scratch\result-filt.txt
del %2
move c:\scratch\result-filt.txt %2
echo !!!!!BOOT/FILE VIRUS FOUND!!!! in file: %4 >> %2

: rem sender
c:\programme\unixutils\grep -i return-path: %5 > c:\scratch\scratch.tmp
c:\programme\unixutils\head -1 c:\scratch\scratch.tmp > c:\scratch\scratch2.tmp
c:\programme\unixutils\cut -d " " -f 2 c:\scratch\scratch2.tmp > c:\scratch\scratch.tmp
c:\programme\unixutils\sed "s/[<>]//g" c:\scratch\scratch.tmp > c:\scratch\tf.txt

: rem do the same with windows onboard tools
: rem find /i "return-path:" %5 >  c:\scratch\scratch.tmp
: rem for /f "tokens=2" %%a in (c:\scratch\scratch.tmp) do echo %%a > c:\scratch\tf.txt
: rem which does not work under all circumstances, it seems...

: rem addressee & subject
c:\programme\unixutils\grep -i to: %5 > c:\scratch\scratch.tmp
c:\programme\unixutils\grep -i subject: %5 >> c:\scratch\scratch.tmp
c:\programme\unixutils\grep -i message-id: %5 >> c:\scratch\scratch.tmp
echo. >> %2
echo The message: >> %2
type c:\scratch\scratch.tmp >> %2
echo has NOT been delivered due to a VIRUS INFECTION! >> %2

c:\programme\batches\blat.exe c:\programme\mercury32\non-delivery.txt -tf c:\scratch\tf.txt -subject "Non-delivery Notification" -attacht %2

goto Finished
:Err4
echo !!VIRUS FOUND IN MEMORY!! >> %2
goto Finished
:Err5
echo Program terminated via ^C or Esc >> %2
goto Finished
:Err6
echo Virus removed >> %2
goto Finished
:Err7
echo Insufficient memory to run the program. >> %2
goto Finished
:Err8
echo *SUSPICIOUS* file found, no known infection >> %2
:Finished
Del %3

exit
